<template lang="html">
  <div class="game-view">
    <div v-if="isAccessVerified && !show404" class="game-view-content">
      <ep-game-thumbnail
        :thumbnail="activeGame.thumbnail"
        v-on:verify-game-play-access="verifyGamePlayAccess()"
        class="thumbnail"></ep-game-thumbnail>
      <ep-game-header
        :gid="activeGame.gid"
        :title="activeGame.title"
        :publisher="activeGame.publisher"
        :price="activeGame.price"
        :meta-data="activeGame.metaData"
        :show-pay-btn="showPayBtn"
        :has-access="hasAccess"
        :is-access-verified="isAccessVerified"
        :has-browser-support="hasBrowserSupport"
        v-on:show-dialog="showDialog($event)"
        v-on:verify-game-play-access="verifyGamePlayAccess()"
        class="header"></ep-game-header>
      <ep-game-header-publisher
        :publisher="activeGame.publisher"
        class="header-publisher"></ep-game-header-publisher>
      <ep-game-media
        v-if="activeGame.mediaList.length > 0"
        class="media"
        :list="activeGame.mediaList"
        v-on:show="showMedia($event)"></ep-game-media>
      <ep-game-about
        :content-string="activeGame.description"
        class="about"></ep-game-about>
      <!--
      <ep-game-comments class="comments"></ep-game-comments>
      -->
    </div>
    <ep-404 v-else-if="show404"></ep-404>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex'

import Ep404 from '~components/404'
import GameThumbnail from '~components/Game/Thumbnail'
import GameHeader from '~components/Game/Header'
import GameHeaderPublisher from '~components/Game/HeaderPublisher'
import GameMedia from '~components/Game/Media'
import GameAbout from '~components/Game/About'
import GameComments from '~components/Game/Comments'

import stripeUtil from '~/utils/stripeUtil'

export default {
  name: 'ep-game-view',
  components: {
    'ep-404': Ep404,
    'ep-game-thumbnail': GameThumbnail,
    'ep-game-header': GameHeader,
    'ep-game-header-publisher': GameHeaderPublisher,
    'ep-game-media': GameMedia,
    'ep-game-about': GameAbout,
    'ep-game-comments': GameComments
  },
  fetch ({ store, params }) {
    return store.dispatch('getActiveGame', params.gid)
    .then(game => {
      store.dispatch('app/updateHeaderTitle', `${game.title}`)
      store.dispatch('app/resetShow404')
    })
    .catch(() => {
      store.dispatch('app/show404Message')
    })
  },
  data () {
    return {
      hasAccess: false,
      accessMessage: '',
      isAccessVerified: false,
      showPayBtn: false
    }
  },
  head () {
    if (!this.activeGame.uid) {
      return {}
    }

    let url = `${process.env.HOST_URL_WWW}/game/${this.activeGame.gid}`
    let title = `${this.activeGame.title} | by ${this.activeGame.publisher.alias}`
    let showDescription = this.activeGame.description.length > 200 ? `${this.activeGame.description.substr(0, 200)}...` : this.activeGame.description
    let description = `Play on Enoplay - ${showDescription}`
    let image = `${this.activeGame.thumbnail}`

    return {
      title: title,
      meta: [
        { hid: 'description', name: 'description', content: description },
        { hid: 'og:url', property: 'og:url', content: url },
        { hid: 'og:title', property: 'og:title', content: title },
        { hid: 'og:description', property: 'og:description', content: description },
        { hid: 'og:image', property: 'og:image', content: image },
        { hid: 'twitter:card', property: 'twitter:card', content: 'summary_large_image' },
        { hid: 'twitter:site', property: 'twitter:site', content: '@enoplay' },
        { hid: 'twitter:url', property: 'twitter:url', content: url },
        { hid: 'twitter:title', property: 'twitter:title', content: title },
        { hid: 'twitter:description', property: 'twitter:description', content: description },
        { hid: 'twitter:image', property: 'twitter:image', content: image }
      ]
    }
  },
  mounted () {
    this.initData()
  },
  updated () {
    this.initPaymentForm()
  },
  watch: {
    '$route.params.gid' () {
      this.initData()
    }
  },
  computed: {
    ...mapState('app', [
      'show404'
    ]),
    ...mapGetters([
      'activeGame',
      'profile'
    ]),
    hasBrowserSupport () {
      if (!this.activeGame || !this.activeGame.systemSupport || !this.activeGame.systemSupport.browser) {
        return
      }

      let browser = this.profile.deviceSettings.browser
      let device = this.profile.deviceSettings.device

      return this.activeGame.systemSupport.browser[browser][device]
    }
  },
  methods: {
    ...mapActions('app', [
      'show404Message',
      'resetShow404'
    ]),
    initData () {
      this.initPaymentForm()
      let gid = this.$route.params.gid

      if (!gid) {
        this.show404Message()
        return
      }

      return this.$store.dispatch('getActiveGame', gid)
      // Ensure profile is retrieved
      .then(() => {
        if (!this.profile.isLoggedIn) {
          return this.$store.dispatch('getProfileInfo')
        }
      })
      .then(() => {
        return this.$store.dispatch('verifyGamePlayAccess', gid)
      })
      .then(response => {
        this.hasAccess = response.hasAccess
        this.isAccessVerified = true
      })
      .then(() => {
        this.resetShow404()
      })
      .catch(() => {
        this.show404Message()
      })
    },
    initPaymentForm () {
      if (this.activeGame.title) {
        stripeUtil.initCheckout(this.onCheckoutLoaded, this.submitPaymentForm)
      }
    },
    onCheckoutLoaded () {
      this.showPayBtn = true
    },
    submitPaymentForm (token) {
      this.$store.dispatch('purchaseGame', {
        gid: this.activeGame.gid,
        token
      })
      .then(() => {
        this.navigateToPlay()
      })
      .catch(() => { /* Do nothing for now */ })
    },
    verifyGamePlayAccess () {
      if (this.hasAccess) {
        this.navigateToPlay()
        return
      }

      if (!this.profile.isLoggedIn) {
        this.showDialog('signin')
        return
      }

      stripeUtil.openPaymentDialog({
        amount: this.activeGame.price.amount || 0,
        name: this.activeGame.title,
        description: `by ${this.activeGame.publisher.alias}`,
        email: this.profile.email,
        image: this.activeGame.thumbnail
      })
    },
    navigateToPlay () {
      this.$router.push({
        name: 'play-gid',
        params: { gid: this.activeGame.gid }
      })
    },
    showDialog (option) {
      this.$emit('dialog-selected', option)
    },
    showMedia (media) {
      this.$emit('show-media', media)
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';

.header, .header-publisher, .media, .about, .comments {
  border-bottom: 1px solid #dcdcdc;
}

.nothing-here-message {
  padding: 20px;
}
</style>
